package it.gotoandplay.smartfoxserver.admin;

import it.gotoandplay.smartfoxserver.SmartFoxServer;
import it.gotoandplay.smartfoxserver.data.User;
import java.util.logging.Logger;

public class HaltTask extends Thread
{
  static final long HALT_DELAY = 10000L;
  User u;

  public HaltTask(User who)
  {
    super("haltThread");
    this.u = who;
    setDaemon(false);
    start();
  }

  public void run()
  {
    try
    {
      Thread.sleep(10000L);

      SmartFoxServer.getInstance().halt(this.u);
    }
    catch (InterruptedException ie)
    {
      SmartFoxServer.log.severe("HaltTask Interrupted, could not halt server!");
    }
  }
}