package it.gotoandplay.smartfoxserver.admin;

import it.gotoandplay.smartfoxserver.SmartFoxServer;
import it.gotoandplay.smartfoxserver.data.KickedUser;
import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;

public class KickedUserCleanerTask extends AbstractAdminTask
{
  public KickedUserCleanerTask(long delay, boolean looping)
  {
    super(delay, looping);
  }

  public void execute()
  {
    Collection items;
    HashMap map = SmartFoxServer.getInstance().getKickedUsers();

    synchronized (map)
    {
      items = map.values();

      for (Iterator i = items.iterator(); i.hasNext(); )
      {
        KickedUser ku = (KickedUser)i.next();
        ku.isBannable();
      }
    }
  }
}