package it.gotoandplay.smartfoxserver.admin;

import it.gotoandplay.smartfoxserver.SmartFoxServer;
import it.gotoandplay.smartfoxserver.data.User;
import java.io.PrintStream;
import java.util.logging.Logger;

public class RestartTask extends Thread
{
  static final long RESTART_DELAY = 10000L;
  User u;

  public RestartTask(User who)
  {
    super("restarterThread");
    this.u = who;
    setDaemon(false);

    start();
  }

  public void run()
  {
    try
    {
      Thread.sleep(10000L);

      SmartFoxServer.getInstance().restart(this.u);
    }
    catch (InterruptedException ie)
    {
      SmartFoxServer.log.severe("RestartTask Interrupted, could not restart server!");
    }
    catch (Exception e)
    {
      System.out.println("AAAAAAAAAAAAARGH");
      e.printStackTrace();
    }
  }
}