package it.gotoandplay.smartfoxserver.crypto;

import java.util.Random;

public class SecretKeyGenerator
{
  private static final int MIN_LEN = 8;
  private static final int MAX_LEN = 24;
  private static final int ASCII_MIN = 65;
  private static final int ASCII_MAX = 126;
  private static SecretKeyGenerator _instance;

  public static SecretKeyGenerator instance()
  {
    if (_instance == null)
      _instance = new SecretKeyGenerator();

    return _instance;
  }

  public String getKey()
  {
    Random rnd = new Random();

    int len = 8 + rnd.nextInt(16);

    return keyGen(len);
  }

  private String keyGen(int len)
  {
    StringBuffer sb = new StringBuffer();
    Random rnd = new Random(System.currentTimeMillis());

    for (int i = 0; i < len; ++i)
    {
      char c = (char)(65 + rnd.nextInt(61));
      sb.append(c);
    }

    return sb.toString();
  }
}