package it.gotoandplay.smartfoxserver.data.buddylist;

public class PermissionRequestKey
{
  private String requester;
  private String target;

  public PermissionRequestKey(String requester, String target)
  {
    this.requester = requester;
    this.target = target;
  }

  public String getRequester()
  {
    return this.requester;
  }

  public void setRequester(String requester)
  {
    this.requester = requester;
  }

  public String getTarget()
  {
    return this.target;
  }

  public void setTarget(String target)
  {
    this.target = target;
  }

  public boolean equals(Object obj)
  {
    boolean isEqual = false;

    if (obj instanceof PermissionRequestKey)
    {
      PermissionRequestKey prk = (PermissionRequestKey)obj;

      if ((prk.getRequester().equals(this.requester)) && (prk.getTarget().equals(this.target)))
        isEqual = true;
    }

    return isEqual;
  }

  public String toString()
  {
    return "{ Source: " + this.requester + ", Target: " + this.target + " }";
  }

  public int hashCode()
  {
    return (this.requester.hashCode() + this.target.hashCode());
  }
}