package it.gotoandplay.smartfoxserver.extensions.examples;

import it.gotoandplay.smartfoxserver.data.buddylist.StorableBuddyList;
import it.gotoandplay.smartfoxserver.data.buddylist.persistence.AbstractBuddyPersister;
import java.io.PrintStream;

public class BasicBuddyPersister extends AbstractBuddyPersister
{
  public void init(Object param)
  {
    System.out.println("Hello, the BuddyPersister was initialized!");
  }

  public void destroy(Object param)
  {
    System.out.println("Farewell, the BuddyPersister is shutting down.");
  }

  public StorableBuddyList loadList(String userName)
  {
    System.out.println("Pretending to load the buddy list... will return a NULL.");
    return null;
  }

  public boolean saveList(String userName, StorableBuddyList buddyList)
  {
    System.out.println("Pretending to save the buddy list... just for test");
    return false;
  }
}