package it.gotoandplay.smartfoxserver.extensions.examples.test;

import it.gotoandplay.smartfoxserver.data.User;
import it.gotoandplay.smartfoxserver.events.InternalEventObject;
import it.gotoandplay.smartfoxserver.extensions.AbstractExtension;
import it.gotoandplay.smartfoxserver.lib.ActionscriptObject;
import it.gotoandplay.smartfoxserver.test.TestSingleton;
import java.io.PrintStream;
import java.util.Random;

public class StaticMembers extends AbstractExtension
{
  public void init()
  {
    System.out.println("--- Static Members Text INIT ---");
    TestSingleton singleton = TestSingleton.getInstance();
    System.out.println("My Singleton id -> " + singleton);

    Random r = new Random();

    singleton.text = "New number ... " + r.nextDouble();
    System.out.println("My Singleton text -> " + singleton.text);

    TestSingleton.A_NUMBER = r.nextInt(10000);
    TestSingleton.A_STRING = "My String ... " + r.nextInt(10000);

    System.out.println("num -> " + TestSingleton.A_NUMBER);
    System.out.println("str ->" + TestSingleton.A_STRING);
  }

  public void destroy()
  {
    System.out.println("--- Static Members Text DESTROY ---");
  }

  public void handleRequest(String cmd, ActionscriptObject ao, User u, int fromRoom)
  {
  }

  public void handleRequest(String cmd, String[] params, User u, int fromRoom)
  {
  }

  public void handleInternalEvent(InternalEventObject ieo)
  {
  }
}