package it.gotoandplay.smartfoxserver.lib;

import it.gotoandplay.smartfoxserver.SmartFoxServer;
import java.io.IOException;
import java.nio.ByteBuffer;
import java.nio.channels.SocketChannel;
import java.util.logging.Logger;

public class NetworkUtils
{
  static final char EOF = 0;
  static final int MAX_WRITE_ERRORS = 5;
  static final int MAX_LOOPS = 1200;
  static Logger log = SmartFoxServer.log;

  public static void prepareBuffer(ServerEvent se, ByteBuffer bb)
  {
    bb.clear();
    bb.put(se.getStrMsg() + '.getBytes());
    bb.flip();
  }

  public static boolean channelWrite(SocketChannel channel, ByteBuffer bb)
  {
    long bytesWritten = 0L;
    long toWrite = bb.remaining();
    try
    {
      bytesWritten = channel.write(bb);
      bb.rewind();
    }
    catch (IOException localIOException)
    {
    }
    catch (Exception localException)
    {
    }

    return true;
  }
}