package it.gotoandplay.smartfoxserver.admin;

public abstract class AbstractAdminTask
  implements ExecutableAdminTask
{
  protected long execTime;
  protected boolean looping;
  protected long delay;

  public AbstractAdminTask(long execTime, boolean looping)
  {
    this.execTime = execTime;
    this.looping = looping;
    this.delay = (execTime - System.currentTimeMillis());
  }

  public AbstractAdminTask(long execTime, boolean looping, long delay)
  {
    long now = System.currentTimeMillis();
    this.execTime = (now + execTime);
    this.looping = looping;
    this.delay = delay;
  }

  public void execute()
  {
  }

  public long getExecTime()
  {
    return this.execTime;
  }

  public void setExecTime(long t)
  {
    this.execTime = t;
  }

  public boolean isLooping()
  {
    return this.looping;
  }

  public long getDelay()
  {
    return this.delay;
  }
}