package it.gotoandplay.smartfoxserver.admin;

import it.gotoandplay.smartfoxserver.SmartFoxServer;
import it.gotoandplay.smartfoxserver.controllers.SystemHandler;
import it.gotoandplay.smartfoxserver.data.BannedUser;
import java.nio.channels.SocketChannel;

public class BanUserTask extends AbstractAdminTask
{
  private SocketChannel channelToKick;
  private String uName;
  private String uIp;

  public BanUserTask(SocketChannel channelToKick, long delay, boolean looping, String uName, String uIp)
  {
    super(delay, looping);
    this.channelToKick = channelToKick;
    this.uName = uName;
    this.uIp = uIp;
  }

  public void execute()
  {
    SmartFoxServer.getInstance().getSysHandler().kickUser(this.channelToKick);
    SmartFoxServer.getInstance().addBannedUser(new BannedUser(this.uName, this.uIp));
  }
}