package it.gotoandplay.smartfoxserver.data;

import java.io.Serializable;

public class BannedUser
  implements Serializable
{
  private static final long serialVersionUID = 1L;
  private String name;
  private String ip;
  private long banDate;

  public BannedUser(String name, String ip)
  {
    this.name = name;
    this.ip = ip;
    this.banDate = System.currentTimeMillis();
  }

  public String getName()
  {
    return this.name;
  }

  public String getIp()
  {
    return this.ip;
  }

  public long getBanDate()
  {
    return this.banDate;
  }

  public boolean equals(BannedUser bu)
  {
    if (this.ip == null) break label46;
    if (this.ip.equals(bu.getIp())) {
      return true;
    }

    label46: return ((this.name != null) && 
      (this.name.equals(bu.getName())));
  }
}