package it.gotoandplay.smartfoxserver.data;

import java.util.Collection;
import java.util.HashMap;

public class ModeratorManager
{
  private HashMap modList;
  private boolean isActive;

  public ModeratorManager()
  {
    this.modList = new HashMap();
  }

  public void addMod(Moderator m)
  {
    this.modList.put(m.getName(), m);
  }

  public Moderator getMod(String key)
  {
    return ((Moderator)this.modList.get(key));
  }

  public void setIsActive(boolean b)
  {
    this.isActive = b;
  }

  public boolean getIsActive()
  {
    return this.isActive;
  }

  public boolean isModerator(String name, String pwd)
  {
    boolean isMod = false;

    Moderator mod = getMod(name);

    if ((mod != null) && 
      (mod.getPwd().equals(pwd)))
      isMod = true;

    return isMod;
  }

  public Collection getModList()
  {
    return this.modList.values();
  }

  public void clearList()
  {
    if (this.modList.size() > 0)
      this.modList.clear();
  }
}