package it.gotoandplay.smartfoxserver.data.buddylist;

import java.util.Map;

public class LoadableBuddyItem
{
  private String name;
  private boolean active;
  private int id;
  private int roomId;
  private boolean ignored;
  private Map<String, String> variables;

  public LoadableBuddyItem(String name, boolean active, int roomId, int id, boolean ignored)
  {
    this.name = name;
    this.active = active;
    this.roomId = roomId;
    this.id = id;
    this.ignored = ignored;
  }

  public String getName()
  {
    return this.name;
  }

  public int getRoomId()
  {
    return this.roomId;
  }

  public boolean isActive()
  {
    return this.active;
  }

  public int getUserId()
  {
    return this.id;
  }

  public boolean isIgnored()
  {
    return this.ignored;
  }

  public Map<String, String> getVariables()
  {
    return this.variables;
  }

  public void setVariables(Map<String, String> variables)
  {
    this.variables = variables;
  }
}