package it.gotoandplay.smartfoxserver.data.buddylist;

import java.util.Map;

public class StorableBuddyItem
{
  public String name;
  public boolean isBlocked;
  public Map<String, String> variables;

  public StorableBuddyItem(String name)
  {
    this.name = name;
    this.isBlocked = false;
  }

  public StorableBuddyItem(String name, boolean isBlocked)
  {
    this.name = name;
    this.isBlocked = isBlocked;
  }

  public boolean equals(Object obj)
  {
    return ((obj instanceof StorableBuddyItem) && (((StorableBuddyItem)obj).name.equals(this.name)));
  }
}