package it.gotoandplay.smartfoxserver.extensions.examples;

import it.gotoandplay.smartfoxserver.data.User;
import it.gotoandplay.smartfoxserver.events.InternalEventObject;
import it.gotoandplay.smartfoxserver.extensions.AbstractExtension;
import it.gotoandplay.smartfoxserver.extensions.ExtensionHelper;
import it.gotoandplay.smartfoxserver.lib.ActionscriptObject;

public class SimpleExtension extends AbstractExtension
{
  private ExtensionHelper helper;

  public void init()
  {
    this.helper = ExtensionHelper.instance();

    trace("Hi! The Simple Extension is initializing");
  }

  public void destroy()
  {
    trace("Bye bye! SimpleExtension is shutting down!");
  }

  public void handleRequest(String cmd, ActionscriptObject ao, User u, int fromRoom)
  {
    trace("The command -> " + cmd + " was invoked by user -> " + u.getName());
  }

  public void handleRequest(String cmd, String[] params, User u, int fromRoom)
  {
    trace("The command -> " + cmd + " was invoked by user -> " + u.getName());
  }

  public void handleInternalEvent(InternalEventObject ieo)
  {
    trace("Received a server event --> " + ieo.getEventName());
  }
}