package it.gotoandplay.smartfoxserver.lib;

import it.gotoandplay.smartfoxserver.SmartFoxServer;
import java.io.FileOutputStream;
import java.io.ObjectOutputStream;
import java.io.PrintStream;
import java.util.logging.Logger;

public class ShutdownManager extends Thread
{
  public static String mesg = "The maximum number of connections was reached.";

  public void run()
  {
    System.out.println("\n");
    System.out.println("Shutting down server...\n");

    if ((SmartFoxServer.getInstance() != null) && 
      (SmartFoxServer.getInstance().getBanList() != null))
    {
      try
      {
        FileOutputStream fos = new FileOutputStream("bannedUsers.sfs");
        ObjectOutputStream oos = new ObjectOutputStream(fos);

        oos.writeObject(SmartFoxServer.getInstance().getBanList());
        oos.flush();
        oos.close();
      }
      catch (Exception e)
      {
        SmartFoxServer.log.severe("Error while handling the sudden shutdown:  " + e.getMessage());
        e.printStackTrace();
      }
    }
  }
}